// ダイアログサイズ
var WINDOW_WIDTH  = 300;
var WINDOW_HEIGHT = 300;
// 色んなところのマージン
var PADDING       = 4;
// パネルサイズ
var PANEL_WIDTH   = WINDOW_WIDTH - PADDING * 2;
var PANEL_HEIGHT  = WINDOW_HEIGHT - PADDING * 2;
// コントロールの高さ
var CTRL_HEIGHT = 25;
// ボタン達の横幅 ボタンは全部で4つ配置するので 1/4
var BUTTON_WIDTH = PANEL_WIDTH / 3.9 - PADDING * 2;

// ダイアログ作成
var win = new Window('dialog', "印刷", {
    x     : 1100,
    y     : 500,
    width : WINDOW_WIDTH,
    height: WINDOW_HEIGHT,
}, {
    resizeable: false,
});
// パネル作成
win.panel = win.add('panel', {
    x     : PADDING,
    y     : PADDING,
    width : PANEL_WIDTH,
    height: PANEL_HEIGHT,
});
// 選択したファイルたちを表示するリストボックス
win.panel.fileListbox = win.panel.add('listbox', {
    x     : PADDING,
    y     : CTRL_HEIGHT * 1 + PADDING * 2,
    width : PANEL_WIDTH - PADDING * 2,
    height: PANEL_HEIGHT - (CTRL_HEIGHT * 2 + PADDING * 3) - (CTRL_HEIGHT + PADDING * 2),
}, undefined, {
    multiselect: true
});
var btnCnt = 0;
// ファイル選択ダイアログを呼び出すボタン
win.panel.openBtn = win.panel.add('button', {
    x     : BUTTON_WIDTH * btnCnt + PADDING * (btnCnt + 1),
    y     : PANEL_HEIGHT - CTRL_HEIGHT - PADDING,
    width : BUTTON_WIDTH,
    height: CTRL_HEIGHT,
}, "Open");
btnCnt++;
// 選択したファイルをリストから削除するボタン
win.panel.removeBtn = win.panel.add('button', {
    x     : BUTTON_WIDTH * btnCnt + PADDING * (btnCnt + 1),
    y     : PANEL_HEIGHT - CTRL_HEIGHT - PADDING,
    width : BUTTON_WIDTH,
    height: CTRL_HEIGHT,
}, "Remove");
btnCnt++;
// キャンセルボタン
win.panel.cancelBtn = win.panel.add('button', {
    x     : BUTTON_WIDTH * btnCnt + PADDING * (btnCnt + 1),
    y     : PANEL_HEIGHT - CTRL_HEIGHT - PADDING,
    width : BUTTON_WIDTH,
    height: CTRL_HEIGHT,
}, "Cancel", {
    name: "cancel"
});
btnCnt++;
// 実行ボタン
win.panel.okBtn = win.panel.add('button', {
    x     : BUTTON_WIDTH * btnCnt + PADDING * (btnCnt + 1),
    y     : PANEL_HEIGHT - CTRL_HEIGHT - PADDING,
    width : BUTTON_WIDTH,
    height: CTRL_HEIGHT,
}, "PRINT!!", {
    name: "ok"
});
btnCnt++;
// ファイル選択ボタンのクリックイベント
win.panel.openBtn.onClick = function() {
    // ファイル選択ダイアログの表示（epsまたはaiファイルでフィルタ）
    var files = File.openDialog("Please select file you want to print.", (function(f){
        return f.name.split(".").slice(-1) == "eps" || "ai" || f instanceof Folder;
    }), true);
    if (files == null) {
        return;
    }
    // ファイル名をリストボックスに追加
    for (var i = 0; i < files.length; i++) {
        var _file = files[i];
        var _item = win.panel.fileListbox.add("item", _file.fullName.split("/").slice(-1)[0]);
    // リストアイテムにFileオブジェクトを保存
        _item._file = _file
    }
}
// 削除ボタンのクリックイベント
win.panel.removeBtn.onClick = function() {
    // リストの中の選択しているファイルをリストから削除
    for (var i = win.panel.fileListbox.selection.length - 1; i >= 0 ; i--) {
        win.panel.fileListbox.remove(win.panel.fileListbox.selection[i].index)
    }
}
// ダイアログの表示
var res = win.show();
(function() {
		if (res != 1) return;
// プリントオプション
		var options = new PrintOptions();
		options.printPreset = "[デフォルト]";//　使用するプリントプリセット名を入力してください。
		printJobOptions= new PrintJobOptions();
		options.jobOptions = printJobOptions;
		printJobOptions.copies = 1;//部数
// 選択しているファイルでループ
		for (var i = 0; i < win.panel.fileListbox.items.length; i++) {
// 一個ずつ開いていく
			var doc = open(win.panel.fileListbox.items[i]._file);
			var docFile = new File(doc.fullName);
			var docName = docFile.fullName.split("/").slice(-1)[0].split(".")[0];
			var docDir = docFile.parent;
			// プリント
			app.documents[0].print(options);
// 開いたファイルを保存せずに閉じる
			activeDocument.close(SaveOptions.DONOTSAVECHANGES);
		}
})();